/**
  ******************************************************************************
  * @file    font24.c
  * @author  MCD Application Team
  * @version V1.0.0
  * @date    18-February-2014
  * @brief   This file provides text font24 for STM32xx-EVAL's LCD driver.
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; COPYRIGHT(c) 2014 STMicroelectronics</center></h2>
  *
  * Redistribution and use in source and binary forms, with or without modification,
  * are permitted provided that the following conditions are met:
  *   1. Redistributions of source code must retain the above copyright notice,
  *      this list of conditions and the following disclaimer.
  *   2. Redistributions in binary form must reproduce the above copyright notice,
  *      this list of conditions and the following disclaimer in the documentation
  *      and/or other materials provided with the distribution.
  *   3. Neither the name of STMicroelectronics nor the names of its contributors
  *      may be used to endorse or promote products derived from this software
  *      without specific prior written permission.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
  * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  *
  ******************************************************************************
  */

/* Includes ------------------------------------------------------------------*/
#include "fonts.h"
#include <pgmspace.h>

const uint8_t Font24_Table_7seg [] PROGMEM =
{
	// @0 ' ' (17 pixels wide)
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        

	// @72 '!' (17 pixels wide)
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x03,0x80,0x00, //      ###               
	0x03,0x80,0x00, //      ###               
	0x03,0x80,0x00, //      ###               
	0x03,0x80,0x00, //      ###               
	0x03,0x80,0x00, //      ###               
	0x03,0x80,0x00, //      ###               
	0x03,0x80,0x00, //      ###               
	0x03,0x80,0x00, //      ###               
	0x03,0x80,0x00, //      ###               
	0x01,0x00,0x00, //       #                
	0x01,0x00,0x00, //       #                
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x03,0x80,0x00, //      ###               
	0x03,0x80,0x00, //      ###               
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        

	// @144 '"' (17 pixels wide)
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x0e,0x70,0x00, //    ###  ###            
	0x0e,0x70,0x00, //    ###  ###            
	0x0e,0x70,0x00, //    ###  ###            
	0x04,0x20,0x00, //     #    #             
	0x04,0x20,0x00, //     #    #             
	0x04,0x20,0x00, //     #    #             
	0x04,0x20,0x00, //     #    #             
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        

	// @216 '#' (17 pixels wide)
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x06,0x60,0x00, //     ##  ##             
	0x06,0x60,0x00, //     ##  ##             
	0x06,0x60,0x00, //     ##  ##             
	0x06,0x60,0x00, //     ##  ##             
	0x06,0x60,0x00, //     ##  ##             
	0x3f,0xf8,0x00, //  ###########           
	0x3f,0xf8,0x00, //  ###########           
	0x06,0x60,0x00, //     ##  ##             
	0x0c,0xc0,0x00, //    ##  ##              
	0x3f,0xf8,0x00, //  ###########           
	0x3f,0xf8,0x00, //  ###########           
	0x0c,0xc0,0x00, //    ##  ##              
	0x0c,0xc0,0x00, //    ##  ##              
	0x0c,0xc0,0x00, //    ##  ##              
	0x0c,0xc0,0x00, //    ##  ##              
	0x0c,0xc0,0x00, //    ##  ##              
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        

	// @288 '$' (17 pixels wide)
	0x00,0x00,0x00, //                        
	0x01,0x80,0x00, //       ##               
	0x01,0x80,0x00, //       ##               
	0x07,0xb0,0x00, //     #### ##            
	0x0f,0xf0,0x00, //    ########            
	0x18,0x70,0x00, //   ##    ###            
	0x18,0x70,0x00, //   ##    ###            
	0x1c,0x00,0x00, //   ###                  
	0x0f,0x80,0x00, //    #####               
	0x07,0xe0,0x00, //     ######             
	0x00,0xf0,0x00, //        ####            
	0x18,0x30,0x00, //   ##     ##            
	0x1c,0x30,0x00, //   ###    ##            
	0x1c,0x70,0x00, //   ###   ###            
	0x1f,0xe0,0x00, //   ########             
	0x1b,0xc0,0x00, //   ## ####              
	0x01,0x80,0x00, //       ##               
	0x01,0x80,0x00, //       ##               
	0x01,0x80,0x00, //       ##               
	0x01,0x80,0x00, //       ##               
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        

	// @360 '%' (17 pixels wide)
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x07,0x80,0x00, //     ####               
	0x0f,0xc0,0x00, //    ######              
	0x1c,0xe0,0x00, //   ###  ###             
	0x18,0x60,0x00, //   ##    ##             
	0x18,0x60,0x00, //   ##    ##             
	0x1c,0xe0,0x00, //   ###  ###             
	0x0f,0xf8,0x00, //    #########           
	0x07,0xe0,0x00, //     ######             
	0x1f,0xf0,0x00, //   #########            
	0x07,0x38,0x00, //     ###  ###           
	0x06,0x18,0x00, //     ##    ##           
	0x06,0x18,0x00, //     ##    ##           
	0x07,0x38,0x00, //     ###  ###           
	0x03,0xf0,0x00, //      ######            
	0x01,0xe0,0x00, //       ####             
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        

	// @432 '&' (17 pixels wide)
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x03,0xf0,0x00, //      ######            
	0x07,0xf0,0x00, //     #######            
	0x0c,0x60,0x00, //    ##   ##             
	0x0c,0x00,0x00, //    ##                  
	0x0c,0x00,0x00, //    ##                  
	0x06,0x00,0x00, //     ##                 
	0x07,0x00,0x00, //     ###                
	0x0f,0x9c,0x00, //    #####  ###          
	0x1d,0xfc,0x00, //   ### #######          
	0x18,0xf0,0x00, //   ##   ####            
	0x18,0x70,0x00, //   ##    ###            
	0x0f,0xfc,0x00, //    ##########          
	0x07,0xdc,0x00, //     ##### ###          
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        

	// @504 ''' (17 pixels wide)
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x03,0x80,0x00, //      ###               
	0x03,0x80,0x00, //      ###               
	0x03,0x80,0x00, //      ###               
	0x01,0x00,0x00, //       #                
	0x01,0x00,0x00, //       #                
	0x01,0x00,0x00, //       #                
	0x01,0x00,0x00, //       #                
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        

	// @576 '(' (17 pixels wide)
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x18,0x00, //           ##           
	0x00,0x38,0x00, //          ###           
	0x00,0x70,0x00, //         ###            
	0x00,0xf0,0x00, //        ####            
	0x00,0xe0,0x00, //        ###             
	0x00,0xe0,0x00, //        ###             
	0x01,0xc0,0x00, //       ###              
	0x01,0xc0,0x00, //       ###              
	0x01,0xc0,0x00, //       ###              
	0x01,0xc0,0x00, //       ###              
	0x01,0xc0,0x00, //       ###              
	0x01,0xc0,0x00, //       ###              
	0x00,0xe0,0x00, //        ###             
	0x00,0xe0,0x00, //        ###             
	0x00,0x70,0x00, //         ###            
	0x00,0x70,0x00, //         ###            
	0x00,0x38,0x00, //          ###           
	0x00,0x18,0x00, //           ##           
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        

	// @648 ')' (17 pixels wide)
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x18,0x00,0x00, //   ##                   
	0x1c,0x00,0x00, //   ###                  
	0x0e,0x00,0x00, //    ###                 
	0x0e,0x00,0x00, //    ###                 
	0x07,0x00,0x00, //     ###                
	0x07,0x00,0x00, //     ###                
	0x03,0x80,0x00, //      ###               
	0x03,0x80,0x00, //      ###               
	0x03,0x80,0x00, //      ###               
	0x03,0x80,0x00, //      ###               
	0x03,0x80,0x00, //      ###               
	0x03,0x80,0x00, //      ###               
	0x07,0x00,0x00, //     ###                
	0x07,0x00,0x00, //     ###                
	0x0f,0x00,0x00, //    ####                
	0x0e,0x00,0x00, //    ###                 
	0x1c,0x00,0x00, //   ###                  
	0x18,0x00,0x00, //   ##                   
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        

	// @720 '*' (17 pixels wide)
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x01,0x80,0x00, //       ##               
	0x01,0x80,0x00, //       ##               
	0x01,0x80,0x00, //       ##               
	0x1d,0xb8,0x00, //   ### ## ###           
	0x1f,0xf8,0x00, //   ##########           
	0x07,0xe0,0x00, //     ######             
	0x03,0xc0,0x00, //      ####              
	0x03,0xc0,0x00, //      ####              
	0x06,0x60,0x00, //     ##  ##             
	0x06,0x60,0x00, //     ##  ##             
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        

	// @792 '+' (17 pixels wide)
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x01,0x80,0x00, //       ##               
	0x01,0x80,0x00, //       ##               
	0x01,0x80,0x00, //       ##               
	0x01,0x80,0x00, //       ##               
	0x01,0x80,0x00, //       ##               
	0x3f,0xfc,0x00, //  ############          
	0x3f,0xfc,0x00, //  ############          
	0x01,0x80,0x00, //       ##               
	0x01,0x80,0x00, //       ##               
	0x01,0x80,0x00, //       ##               
	0x01,0x80,0x00, //       ##               
	0x01,0x80,0x00, //       ##               
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        

	// @864 ',' (17 pixels wide)
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0xe0,0x00, //        ###             
	0x00,0xc0,0x00, //        ##              
	0x01,0xc0,0x00, //       ###              
	0x01,0x80,0x00, //       ##               
	0x01,0x80,0x00, //       ##               
	0x03,0x00,0x00, //      ##                
	0x03,0x00,0x00, //      ##                
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        

	// @936 '-' (17 pixels wide)
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x1f,0xf8,0x00, //   ##########           
	0x1f,0xf8,0x00, //   ##########           
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        

	// @1008 '.' (17 pixels wide)
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x03,0xc0,0x00, //      ####              
	0x03,0xc0,0x00, //      ####              
	0x03,0xc0,0x00, //      ####              
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        

	// @1080 '/' (17 pixels wide)
	0x00,0x18,0x00, //           ##           
	0x00,0x18,0x00, //           ##           
	0x00,0x38,0x00, //          ###           
	0x00,0x30,0x00, //          ##            
	0x00,0x70,0x00, //         ###            
	0x00,0x60,0x00, //         ##             
	0x00,0x60,0x00, //         ##             
	0x00,0xc0,0x00, //        ##              
	0x00,0xc0,0x00, //        ##              
	0x01,0x80,0x00, //       ##               
	0x01,0x80,0x00, //       ##               
	0x03,0x00,0x00, //      ##                
	0x03,0x00,0x00, //      ##                
	0x06,0x00,0x00, //     ##                 
	0x06,0x00,0x00, //     ##                 
	0x0e,0x00,0x00, //    ###                 
	0x0c,0x00,0x00, //    ##                  
	0x1c,0x00,0x00, //   ###                  
	0x18,0x00,0x00, //   ##                   
	0x18,0x00,0x00, //   ##                   
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        

	// @0 ' ' (17 pixels wide)
	0x00,0x00,0x00, //                        
	0x07,0xfc,0x00, //     #########          
	0x07,0xfc,0x00, //     #########          
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x07,0xfc,0x00, //     #########          
	0x07,0xfc,0x00, //     #########          
	0x00,0x00,0x00, //                        

	// @0 ' ' (17 pixels wide)
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        

	// @0 ' ' (17 pixels wide)
	0x00,0x00,0x00, //                        
	0x07,0xfc,0x00, //     #########          
	0x07,0xfc,0x00, //     #########          
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x07,0xfc,0x00, //     #########          
	0x07,0xfc,0x00, //     #########          
	0x18,0x00,0x00, //   ##                   
	0x18,0x00,0x00, //   ##                   
	0x18,0x00,0x00, //   ##                   
	0x18,0x00,0x00, //   ##                   
	0x18,0x00,0x00, //   ##                   
	0x18,0x00,0x00, //   ##                   
	0x18,0x00,0x00, //   ##                   
	0x18,0x00,0x00, //   ##                   
	0x07,0xfc,0x00, //     #########          
	0x07,0xfc,0x00, //     #########          
	0x00,0x00,0x00, //                        

	// @0 ' ' (17 pixels wide)
	0x00,0x00,0x00, //                        
	0x07,0xfc,0x00, //     #########          
	0x07,0xfc,0x00, //     #########          
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x07,0xfc,0x00, //     #########          
	0x07,0xfc,0x00, //     #########          
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x07,0xfc,0x00, //     #########          
	0x07,0xfc,0x00, //     #########          
	0x00,0x00,0x00, //                        

	// @0 ' ' (17 pixels wide)
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x07,0xfc,0x00, //     #########          
	0x07,0xfc,0x00, //     #########          
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        

	// @0 ' ' (17 pixels wide)
	0x00,0x00,0x00, //                        
	0x07,0xfc,0x00, //     #########          
	0x07,0xfc,0x00, //     #########          
	0x18,0x00,0x00, //   ##                   
	0x18,0x00,0x00, //   ##                   
	0x18,0x00,0x00, //   ##                   
	0x18,0x00,0x00, //   ##                   
	0x18,0x00,0x00, //   ##                   
	0x18,0x00,0x00, //   ##                   
	0x18,0x00,0x00, //   ##                   
	0x18,0x00,0x00, //   ##                   
	0x07,0xfc,0x00, //     #########          
	0x07,0xfc,0x00, //     #########          
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x07,0xfc,0x00, //     #########          
	0x07,0xfc,0x00, //     #########          
	0x00,0x00,0x00, //                        

	// @0 ' ' (17 pixels wide)
	0x00,0x00,0x00, //                        
	0x07,0xfc,0x00, //     #########          
	0x07,0xfc,0x00, //     #########          
	0x18,0x00,0x00, //   ##                   
	0x18,0x00,0x00, //   ##                   
	0x18,0x00,0x00, //   ##                   
	0x18,0x00,0x00, //   ##                   
	0x18,0x00,0x00, //   ##                   
	0x18,0x00,0x00, //   ##                   
	0x18,0x00,0x00, //   ##                   
	0x18,0x00,0x00, //   ##                   
	0x07,0xfc,0x00, //     #########          
	0x07,0xfc,0x00, //     #########          
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x0f,0xfc,0x00, //    ##########          
	0x0f,0xfc,0x00, //    ##########          
	0x00,0x00,0x00, //                        

	// @0 ' ' (17 pixels wide)
	0x00,0x00,0x00, //                        
	0x0f,0xfc,0x00, //    ##########          
	0x0f,0xfc,0x00, //    ##########          
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        

	// @0 ' ' (17 pixels wide)
	0x00,0x00,0x00, //                        
	0x07,0xfc,0x00, //     #########          
	0x07,0xfc,0x00, //     #########          
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x07,0xfc,0x00, //     #########          
	0x07,0xfc,0x00, //     #########          
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x07,0xfc,0x00, //     #########          
	0x07,0xfc,0x00, //     #########          
	0x00,0x00,0x00, //                        

	// @0 ' ' (17 pixels wide)
	0x00,0x00,0x00, //                        
	0x07,0xfc,0x00, //     #########          
	0x07,0xfc,0x00, //     #########          
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x18,0x03,0x00, //   ##         ##        
	0x07,0xfc,0x00, //     #########          
	0x07,0xfc,0x00, //     #########          
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x03,0x00, //              ##        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        

	// @1872 ':' (17 pixels wide)
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0xf0,0x00, //        ####            
	0x00,0xf0,0x00, //        ####            
	0x00,0xf0,0x00, //        ####            
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0xf0,0x00, //        ####            
	0x00,0xf0,0x00, //        ####            
	0x00,0xf0,0x00, //        ####            
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00, //                        
	0x00,0x00,0x00 //                        
};

sFONT Font24_7seg = {
  Font24_Table_7seg,
  17, /* Width */
  24, /* Height */
};

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/

