#include "be_constobj.h"

static be_define_const_map_slots(m_libgpio_map) {
    { be_const_key(MAX31855CLK, -1), be_const_int(79) },
    { be_const_key(DHT11_OUT, 197), be_const_int(40) },
    { be_const_key(PZEM004_RX, 113), be_const_int(47) },
    { be_const_key(BS814_DAT, 115), be_const_int(215) },
    { be_const_key(ROT1B_NP, -1), be_const_int(212) },
    { be_const_key(WEBCAM_HREF, -1), be_const_int(161) },
    { be_const_key(SPI_CLK, 233), be_const_int(23) },
    { be_const_key(TCP_TX, -1), be_const_int(171) },
    { be_const_key(SM16716_DAT, 72), be_const_int(92) },
    { be_const_key(AZ_RXD, 136), be_const_int(77) },
    { be_const_key(PWM1, -1), be_const_int(13) },
    { be_const_key(EXS_ENABLE, -1), be_const_int(129) },
    { be_const_key(ETH_PHY_POWER, -1), be_const_int(173) },
    { be_const_key(HIGH, -1), be_const_int(1) },
    { be_const_key(ETH_PHY_MDIO, -1), be_const_int(175) },
    { be_const_key(MP3_DFR562, 11), be_const_int(67) },
    { be_const_key(HM10_RX, -1), be_const_int(138) },
    { be_const_key(SSPI_MOSI, -1), be_const_int(27) },
    { be_const_key(KEY1_INV_NP, -1), be_const_int(4) },
    { be_const_key(NONE, -1), be_const_int(0) },
    { be_const_key(DDS2382_RX, 18), be_const_int(123) },
    { be_const_key(DSB_OUT, -1), be_const_int(42) },
    { be_const_key(FTC532, -1), be_const_int(195) },
    { be_const_key(ARIRFSEL, 222), be_const_int(99) },
    { be_const_key(pin, -1), be_const_func(gp_pin) },
    { be_const_key(RFRECV, -1), be_const_int(36) },
    { be_const_key(HRXL_RX, -1), be_const_int(144) },
    { be_const_key(HRE_CLOCK, -1), be_const_int(106) },
    { be_const_key(AS608_RX, -1), be_const_int(188) },
    { be_const_key(SDS0X1_TX, -1), be_const_int(54) },
    { be_const_key(TM1637DIO, 112), be_const_int(223) },
    { be_const_key(ILI9488_CS, 138), be_const_int(201) },
    { be_const_key(WEBCAM_VSYNC, 184), be_const_int(160) },
    { be_const_key(TASMOTACLIENT_RST, 224), be_const_int(132) },
    { be_const_key(INPUT, 57), be_const_int(239) },
    { be_const_key(SBR_TX, -1), be_const_int(56) },
    { be_const_key(HPMA_TX, -1), be_const_int(135) },
    { be_const_key(MCP39F5_RX, 41), be_const_int(87) },
    { be_const_key(OUTPUT, 69), be_const_int(2) },
    { be_const_key(AZ_TXD, -1), be_const_int(76) },
    { be_const_key(ADC_BUTTON, -1), be_const_int(150) },
    { be_const_key(ETH_PHY_MDC, -1), be_const_int(174) },
    { be_const_key(ZEROCROSS, -1), be_const_int(236) },
    { be_const_key(AS3935, 147), be_const_int(146) },
    { be_const_key(SSPI_MAX31865_CS1, -1), be_const_int(105) },
    { be_const_key(LEDLNK_INV, 56), be_const_int(18) },
    { be_const_key(RDM6300_RX, -1), be_const_int(113) },
    { be_const_key(TM1638STB, -1), be_const_int(66) },
    { be_const_key(SR04_TRIG, 166), be_const_int(58) },
    { be_const_key(CSE7761_RX, -1), be_const_int(229) },
    { be_const_key(HM10_TX, -1), be_const_int(139) },
    { be_const_key(SM16716_CLK, 111), be_const_int(91) },
    { be_const_key(ADC_TEMP, 120), be_const_int(148) },
    { be_const_key(NRG_SEL_INV, -1), be_const_int(82) },
    { be_const_key(OPEN_DRAIN, -1), be_const_int(16) },
    { be_const_key(ST7789_DC, 196), be_const_int(207) },
    { be_const_key(INPUT_PULLDOWN, 122), be_const_int(9) },
    { be_const_key(SM2135_CLK, 219), be_const_int(126) },
    { be_const_key(WEBCAM_PSCLK, 32), be_const_int(163) },
    { be_const_key(ADC_CT_POWER, 82), be_const_int(153) },
    { be_const_key(OUTPUT_OPEN_DRAIN, -1), be_const_int(18) },
    { be_const_key(CC1101_GDO2, -1), be_const_int(143) },
    { be_const_key(SM2135_DAT, 28), be_const_int(127) },
    { be_const_key(digital_write, -1), be_const_func(gp_digital_write) },
    { be_const_key(GPS_TX, 68), be_const_int(137) },
    { be_const_key(TFMINIPLUS_RX, -1), be_const_int(235) },
    { be_const_key(RC522_CS, -1), be_const_int(196) },
    { be_const_key(PMS5003_TX, -1), be_const_int(52) },
    { be_const_key(DDS2382_TX, -1), be_const_int(122) },
    { be_const_key(IEM3000_RX, 133), be_const_int(180) },
    { be_const_key(ZIGBEE_RX, -1), be_const_int(112) },
    { be_const_key(ZIGBEE_RST, -1), be_const_int(181) },
    { be_const_key(HPMA_RX, -1), be_const_int(134) },
    { be_const_key(SDS0X1_RX, -1), be_const_int(55) },
    { be_const_key(WEBCAM_RESET, -1), be_const_int(155) },
    { be_const_key(CNTR1, 249), be_const_int(11) },
    { be_const_key(ADC_LIGHT, 231), be_const_int(149) },
    { be_const_key(HRE_DATA, 34), be_const_int(107) },
    { be_const_key(OUTPUT_HI, -1), be_const_int(120) },
    { be_const_key(LED1_INV, 176), be_const_int(10) },
    { be_const_key(LMT01, -1), be_const_int(178) },
    { be_const_key(DSB, -1), be_const_int(41) },
    { be_const_key(CSE7766_RX, -1), be_const_int(97) },
    { be_const_key(SBR_RX, -1), be_const_int(57) },
    { be_const_key(PROJECTOR_CTRL_TX, 148), be_const_int(224) },
    { be_const_key(DI, 211), be_const_int(94) },
    { be_const_key(PZEM0XX_TX, -1), be_const_int(46) },
    { be_const_key(SENSOR_END, -1), be_const_int(240) },
    { be_const_key(A4988_ENA, 97), be_const_int(118) },
    { be_const_key(WEBCAM_PSRCS, 46), be_const_int(165) },
    { be_const_key(ELECTRIQ_MOODL_TX, -1), be_const_int(145) },
    { be_const_key(WEBCAM_XCLK, -1), be_const_int(156) },
    { be_const_key(PN532_RXD, -1), be_const_int(90) },
    { be_const_key(BL0940_RX, 195), be_const_int(170) },
    { be_const_key(PMS5003_RX, -1), be_const_int(53) },
    { be_const_key(HALLEFFECT, -1), be_const_int(237) },
    { be_const_key(PWM1_INV, 172), be_const_int(14) },
    { be_const_key(TASMOTACLIENT_RXD, -1), be_const_int(131) },
    { be_const_key(WEBCAM_SIOD, 110), be_const_int(157) },
    { be_const_key(TM1637CLK, 33), be_const_int(222) },
    { be_const_key(IRRECV, -1), be_const_int(34) },
    { be_const_key(SPI_MOSI, -1), be_const_int(22) },
    { be_const_key(TELEINFO_RX, 182), be_const_int(176) },
    { be_const_key(TASMOTACLIENT_RST_INV, -1), be_const_int(133) },
    { be_const_key(PROJECTOR_CTRL_RX, -1), be_const_int(225) },
    { be_const_key(WIEGAND_D0, -1), be_const_int(216) },
    { be_const_key(ADE7953_IRQ, -1), be_const_int(108) },
    { be_const_key(SPI_DC, -1), be_const_int(25) },
    { be_const_key(IRSEND, -1), be_const_int(33) },
    { be_const_key(TFMINIPLUS_TX, 87), be_const_int(234) },
    { be_const_key(I2C_SCL, -1), be_const_int(19) },
    { be_const_key(MAX7219DIN, -1), be_const_int(232) },
    { be_const_key(ROT1A_NP, -1), be_const_int(211) },
    { be_const_key(PZEM017_RX, 156), be_const_int(49) },
    { be_const_key(WINDMETER_SPEED, -1), be_const_int(168) },
    { be_const_key(RC522_RST, -1), be_const_int(191) },
    { be_const_key(SR04_ECHO, 89), be_const_int(59) },
    { be_const_key(BOILER_OT_TX, -1), be_const_int(167) },
    { be_const_key(ZIGBEE_TX, 104), be_const_int(111) },
    { be_const_key(REL1_INV, -1), be_const_int(8) },
    { be_const_key(WS2812, -1), be_const_int(43) },
    { be_const_key(BUZZER, 0), be_const_int(15) },
    { be_const_key(CC1101_GDO0, -1), be_const_int(142) },
    { be_const_key(SWT1_NP, -1), be_const_int(6) },
    { be_const_key(SSPI_DC, 49), be_const_int(30) },
    { be_const_key(ADC_RANGE, 128), be_const_int(152) },
    { be_const_key(OPTION_A, 174), be_const_int(194) },
    { be_const_key(SHELLY_DIMMER_RST_INV, -1), be_const_int(190) },
    { be_const_key(MGC3130_XFER, -1), be_const_int(73) },
    { be_const_key(VL53L0X_XSHUT1, 140), be_const_int(230) },
    { be_const_key(SSD1351_CS, -1), be_const_int(204) },
    { be_const_key(LEDLNK, 63), be_const_int(17) },
    { be_const_key(P9813_DAT, 67), be_const_int(193) },
    { be_const_key(pin_mode, 218), be_const_func(gp_pin_mode) },
    { be_const_key(RF_SENSOR, -1), be_const_int(75) },
    { be_const_key(TELEINFO_ENABLE, -1), be_const_int(177) },
    { be_const_key(RISING, -1), be_const_int(1) },
    { be_const_key(DHT11, -1), be_const_int(37) },
    { be_const_key(SDCARD_CS, -1), be_const_int(210) },
    { be_const_key(ROT1B, 169), be_const_int(103) },
    { be_const_key(TUYA_RX, -1), be_const_int(72) },
    { be_const_key(SSPI_CS, -1), be_const_int(29) },
    { be_const_key(DCKI, -1), be_const_int(95) },
    { be_const_key(XPT2046_CS, -1), be_const_int(227) },
    { be_const_key(DDSU666_RX, -1), be_const_int(125) },
    { be_const_key(A4988_STP, -1), be_const_int(117) },
    { be_const_key(SOLAXX1_RX, -1), be_const_int(110) },
    { be_const_key(NRG_SEL, -1), be_const_int(81) },
    { be_const_key(HX711_DAT, -1), be_const_int(69) },
    { be_const_key(SSPI_MISO, -1), be_const_int(26) },
    { be_const_key(WEBCAM_HSD, -1), be_const_int(164) },
    { be_const_key(GPS_RX, -1), be_const_int(136) },
    { be_const_key(NEOPOOL_RX, -1), be_const_int(219) },
    { be_const_key(PZEM016_RX, -1), be_const_int(48) },
    { be_const_key(CSE7761_TX, -1), be_const_int(228) },
    { be_const_key(OLED_RESET, -1), be_const_int(32) },
    { be_const_key(ADC_INPUT, 101), be_const_int(147) },
    { be_const_key(LE01MR_TX, 80), be_const_int(141) },
    { be_const_key(EPAPER29_CS, 238), be_const_int(202) },
    { be_const_key(DHT22, -1), be_const_int(38) },
    { be_const_key(BACKLIGHT, -1), be_const_int(31) },
    { be_const_key(NRG_CF1, -1), be_const_int(83) },
    { be_const_key(MCP39F5_RST, 1), be_const_int(88) },
    { be_const_key(SDM120_TX, -1), be_const_int(60) },
    { be_const_key(HLW_CF, -1), be_const_int(84) },
    { be_const_key(BOILER_OT_RX, -1), be_const_int(166) },
    { be_const_key(TUYA_TX, -1), be_const_int(71) },
    { be_const_key(NRF24_DC, -1), be_const_int(198) },
    { be_const_key(TM1638DIO, -1), be_const_int(65) },
    { be_const_key(IBEACON_RX, 179), be_const_int(115) },
    { be_const_key(DEEPSLEEP, -1), be_const_int(128) },
    { be_const_key(HJL_CF, -1), be_const_int(85) },
    { be_const_key(DDSU666_TX, 154), be_const_int(124) },
    { be_const_key(MHZ_TXD, -1), be_const_int(44) },
    { be_const_key(MIEL_HVAC_TX, 22), be_const_int(183) },
    { be_const_key(BS814_CLK, 209), be_const_int(214) },
    { be_const_key(SM16716_SEL, -1), be_const_int(93) },
    { be_const_key(KEY1_TC, 48), be_const_int(169) },
    { be_const_key(SWT1, 5), be_const_int(5) },
    { be_const_key(WEBCAM_DATA, 217), be_const_int(159) },
    { be_const_key(PULLDOWN, -1), be_const_int(8) },
    { be_const_key(A4988_MS1, -1), be_const_int(119) },
    { be_const_key(pin_used, -1), be_const_func(gp_pin_used) },
    { be_const_key(IBEACON_TX, 220), be_const_int(114) },
    { be_const_key(NRF24_CS, -1), be_const_int(197) },
    { be_const_key(RXD, -1), be_const_int(101) },
    { be_const_key(NEOPOOL_TX, -1), be_const_int(218) },
    { be_const_key(WEBCAM_SIOC, -1), be_const_int(158) },
    { be_const_key(TASMOTACLIENT_TXD, -1), be_const_int(130) },
    { be_const_key(MAX31855CS, -1), be_const_int(78) },
    { be_const_key(TM1638CLK, -1), be_const_int(64) },
    { be_const_key(ILI9341_CS, -1), be_const_int(199) },
    { be_const_key(PN532_TXD, -1), be_const_int(89) },
    { be_const_key(LOW, -1), be_const_int(0) },
    { be_const_key(SOLAXX1_TX, -1), be_const_int(109) },
    { be_const_key(SDM72_RX, -1), be_const_int(221) },
    { be_const_key(PULLUP, -1), be_const_int(4) },
    { be_const_key(MIEL_HVAC_RX, -1), be_const_int(184) },
    { be_const_key(MAX31855DO, 216), be_const_int(80) },
    { be_const_key(REL1, -1), be_const_int(7) },
    { be_const_key(HX711_SCK, -1), be_const_int(68) },
    { be_const_key(WEBCAM_PCLK, -1), be_const_int(162) },
    { be_const_key(ARIRFRCV, 175), be_const_int(98) },
    { be_const_key(SAIR_TX, -1), be_const_int(50) },
    { be_const_key(digital_read, -1), be_const_func(gp_digital_read) },
    { be_const_key(LE01MR_RX, 125), be_const_int(140) },
    { be_const_key(TX2X_TXD_BLACK, -1), be_const_int(70) },
    { be_const_key(KEY1_INV, -1), be_const_int(3) },
    { be_const_key(ADC_JOY, -1), be_const_int(104) },
    { be_const_key(ST7789_CS, -1), be_const_int(206) },
    { be_const_key(SSD1331_CS, -1), be_const_int(208) },
    { be_const_key(FALLING, -1), be_const_int(2) },
    { be_const_key(SPI_CS, -1), be_const_int(24) },
    { be_const_key(BUZZER_INV, -1), be_const_int(16) },
    { be_const_key(RFSEND, -1), be_const_int(35) },
    { be_const_key(WE517_RX, -1), be_const_int(186) },
    { be_const_key(INPUT_PULLUP, -1), be_const_int(5) },
    { be_const_key(A4988_DIR, 223), be_const_int(116) },
    { be_const_key(SSPI_SCLK, -1), be_const_int(28) },
    { be_const_key(EPAPER42_CS, 252), be_const_int(203) },
    { be_const_key(SDM120_RX, -1), be_const_int(61) },
    { be_const_key(DYP_RX, -1), be_const_int(182) },
    { be_const_key(EPD_DATA, -1), be_const_int(238) },
    { be_const_key(TXD, -1), be_const_int(100) },
    { be_const_key(P9813_CLK, -1), be_const_int(192) },
    { be_const_key(MHZ_RXD, -1), be_const_int(45) },
    { be_const_key(WIEGAND_D1, -1), be_const_int(217) },
    { be_const_key(SSD1331_DC, 90), be_const_int(209) },
    { be_const_key(ADC_PH, -1), be_const_int(213) },
    { be_const_key(CSE7766_TX, -1), be_const_int(96) },
    { be_const_key(ADC_BUTTON_INV, 81), be_const_int(151) },
    { be_const_key(CNTR1_NP, -1), be_const_int(12) },
    { be_const_key(OUTPUT_LO, 85), be_const_int(121) },
    { be_const_key(SHELLY_DIMMER_BOOT0, -1), be_const_int(189) },
    { be_const_key(WEBCAM_PWDN, -1), be_const_int(154) },
    { be_const_key(KEY1, 246), be_const_int(1) },
    { be_const_key(RA8876_CS, 204), be_const_int(205) },
    { be_const_key(SDM630_RX, 171), be_const_int(63) },
    { be_const_key(ILI9341_DC, -1), be_const_int(200) },
    { be_const_key(LED1, 257), be_const_int(9) },
    { be_const_key(SPI_MISO, -1), be_const_int(21) },
    { be_const_key(SSD1351_DC, 30), be_const_int(226) },
    { be_const_key(MAX7219CLK, -1), be_const_int(231) },
    { be_const_key(MCP39F5_TX, -1), be_const_int(86) },
    { be_const_key(ROT1A, -1), be_const_int(102) },
    { be_const_key(TCP_RX, 42), be_const_int(172) },
    { be_const_key(WE517_TX, -1), be_const_int(185) },
    { be_const_key(SAIR_RX, 214), be_const_int(51) },
    { be_const_key(IEM3000_TX, 143), be_const_int(179) },
    { be_const_key(SDM630_TX, -1), be_const_int(62) },
    { be_const_key(KEY1_NP, 251), be_const_int(2) },
    { be_const_key(I2C_SDA, -1), be_const_int(20) },
    { be_const_key(MGC3130_RESET, -1), be_const_int(74) },
    { be_const_key(SI7021, -1), be_const_int(39) },
    { be_const_key(MAX7219CS, 151), be_const_int(233) },
    { be_const_key(SDM72_TX, -1), be_const_int(220) },
    { be_const_key(AS608_TX, 6), be_const_int(187) },
    { be_const_key(CHANGE, -1), be_const_int(4) },
};

static be_define_const_map(
    m_libgpio_map,
    258
);

static be_define_const_module(
    m_libgpio,
    "gpio"
);

BE_EXPORT_VARIABLE be_define_const_native_module(gpio, NULL);
