/*
  hu-HU.h - localization for Hungarian in Hungary for Tasmota

  Copyright (C) 2021  Theo Arends

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _LANGUAGE_HU_HU_H_
#define _LANGUAGE_HU_HU_H_

/*************************** ATTENTION *******************************\
 *
 * Due to memory constraints only UTF-8 is supported.
 * To save code space keep text as short as possible.
 * Time and Date provided by SDK can not be localized (yet).
 * Use online command StateText to translate ON, OFF, HOLD and TOGGLE.
 * Use online command Prefix to translate cmnd, stat and tele.
 *
 * Updated until v9.3.1.1
\*********************************************************************/

//#define LANGUAGE_MODULE_NAME         // Enable to display "Module Generic" (ie Spanish), Disable to display "Generic Module" (ie English)

#define LANGUAGE_LCID 1038
// HTML (ISO 639-1) Language Code
#define D_HTML_LANGUAGE "hu"

// "2017-03-07T11:08:02" - ISO8601:2004
#define D_YEAR_MONTH_SEPARATOR "."
#define D_MONTH_DAY_SEPARATOR "."
#define D_DATE_TIME_SEPARATOR " "
#define D_HOUR_MINUTE_SEPARATOR ":"
#define D_MINUTE_SECOND_SEPARATOR ":"

#define D_DAY3LIST "VasHétKedSzeCsüPénSzo"
#define D_MONTH3LIST "JanFebMárÁprMájJúnJúlAugSzeOktNovDec"

// Non JSON decimal separator
#define D_DECIMAL_SEPARATOR "."

// Common
#define D_ADMIN "Admin"
#define D_AIR_QUALITY "Levegőminőség"
#define D_AP "AP"                    // Access Point
#define D_AS "mint"
#define D_AUTO "AUTO"
#define D_BATT "Batt"                // Short for Battery
#define D_BLINK "Villogás"
#define D_BLINKOFF "Villogás ki"
#define D_BOOT_COUNT "Újraindulások száma"
#define D_BRIGHTLIGHT "Max. fényerő"
#define D_BSSID "BSSID"
#define D_BUTTON "Gomb"
#define D_BY "by"                    // Written by me
#define D_BYTES "Byte-ok"
#define D_CELSIUS "Celsius"
#define D_CHANNEL "Csatorna"
#define D_CO2 "Szén-dioxid"
#define D_CODE "kód"                // Button code
#define D_COLDLIGHT "Hideg fény"
#define D_COMMAND "Parancs"
#define D_CONNECTED "Csatlakoztatva"
#define D_CORS_DOMAIN "CORS Domain"
#define D_COUNT "Szám"
#define D_COUNTER "Számláló"
#define D_CT_POWER "CT erősség"
#define D_CURRENT "Áramerősség"          // As in Voltage and Current
#define D_DATA "Adat"
#define D_DARKLIGHT "Min. fényerő"
#define D_DEBUG "Debug"
#define D_DEWPOINT "Harmatpont"
#define D_DISABLED "Letiltva"
#define D_DISTANCE "Távolság"
#define D_DNS_SERVER "DNS szerver"
#define D_DO "Oldott oxygén"
#define D_DONE "Kész"
#define D_DST_TIME "nyári idő"
#define D_EC "EC"
#define D_ECO2 "eCO₂"
#define D_EMULATION "Emuláció"
#define D_ENABLED "Engedélyezve"
#define D_ERASE "Törlés"
#define D_ERROR "Hiba"
#define D_FAHRENHEIT "Fahrenheit"
#define D_FAILED "Sikertelen"
#define D_FALLBACK "Fallback"
#define D_FALLBACK_TOPIC "fallback topik"
#define D_FALSE "Hamis"
#define D_FILE "Fájl"
#define D_FLOW_RATE "Átfolyás ráta"
#define D_FRAGMENTATION "frag."      // Lower case abbreviated version of fragmentation used in "memory fragmentation"
#define D_FREE_MEMORY "Szabad memória"
#define D_PSR_MAX_MEMORY "PS-RAM memória"
#define D_PSR_FREE_MEMORY "PS-RAM szabad memória"
#define D_FREQUENCY "Frekvencia"
#define D_GAS "Gáz"
#define D_GATEWAY "Átjáró"
#define D_GROUP "Csoport"
#define D_HOST "Hoszt"
#define D_HALL_EFFECT "Hall Effect"
#define D_HOSTNAME "Hosztnév"
#define D_HUMIDITY "Páratartalom"
#define D_ILLUMINANCE "Megvilágítás"
#define D_IMMEDIATE "azonnali"      // Button immediate
#define D_INDEX "Index"
#define D_INFO "Info"
#define D_INFRARED "Infravörös"
#define D_INITIALIZED "Inicializálva"
#define D_IP_ADDRESS "IP cím"
#define D_LIGHT "Fény"
#define D_LWT "LWT"
#define D_LQI "LQI"                  // Zigbee Link Quality Index
#define D_MODULE "Modul"
#define D_MOISTURE "Páratartalom"
#define D_MQTT "MQTT"
#define D_MULTI_PRESS "többes lenyomás"
#define D_NOISE "Zaj"
#define D_NONE "nincs"
#define D_O2 "Oxygén"
#define D_OFF "Ki"
#define D_OFFLINE "Offline"
#define D_OK "OK"
#define D_ON "Be"
#define D_ONLINE "Online"
#define D_ORP "ORP"
#define D_PASSWORD "Jelszó"
#define D_PH "pH"
#define D_PORT "Port"
#define D_POWER_FACTOR "Teljesítménytényező"
#define D_POWERUSAGE "Energiafelhasználás"
#define D_POWERUSAGE_ACTIVE "Aktív teljesítmény"
#define D_POWERUSAGE_APPARENT "Látszólagos teljesítmény"
#define D_POWERUSAGE_REACTIVE "Reaktív teljesítmény"
#define D_PRESSURE "Nyomás"
#define D_PRESSUREATSEALEVEL "Tengerszinti nyomás"
#define D_PROGRAM_FLASH_SIZE "Program flash méret"
#define D_PROGRAM_SIZE "Program méret"
#define D_PROJECT "Projekt"
#define D_RAIN "Eső"
#define D_RANGE "Tartomány"
#define D_RECEIVED "Érkezett"
#define D_RESTART "Újraindítás"
#define D_RESTARTING "Újraindítás"
#define D_RESTART_REASON "Utolsó újraindulás oka"
#define D_RESTORE "Visszaállítás"
#define D_RETAINED "megtartott"
#define D_RULE "Szabály"
#define D_SAVE "Mentés"
#define D_SENSOR "Szenzor"
#define D_SSID "SSID"
#define D_START ""
#define D_STD_TIME "STD"
#define D_STOP "Leállítás"
#define D_SUBNET_MASK "Alhálózati maszk"
#define D_SUBSCRIBE_TO "Feliratkozás a(z)"
#define D_UNSUBSCRIBE_FROM "Leiratkozás a(z)"
#define D_SUCCESSFUL "Sikeres"
#define D_SUNRISE "Napkelte"
#define D_SUNSET "Napnyugta"
#define D_TEMPERATURE "Hőmérséklet"
#define D_TO "-nak"
#define D_TOGGLE "Megfordítás"
#define D_TOPIC "Topic"
#define D_TOTAL_USAGE "Teljes használat"
#define D_TRANSMIT "Továbbít"
#define D_TRUE "Igaz"
#define D_TVOC "TVOC"
#define D_UPGRADE "Frissítés"
#define D_UPLOAD "Feltöltés"
#define D_UPTIME "Üzemidő"
#define D_USER "Felhasználó"
#define D_UTC_TIME "UTC"
#define D_UV_INDEX "UV index"
#define D_UV_INDEX_1 "alacsony"
#define D_UV_INDEX_2 "közepes"
#define D_UV_INDEX_3 "magas"
#define D_UV_INDEX_4 "veszélyes"
#define D_UV_INDEX_5 "égés L1/2"
#define D_UV_INDEX_6 "égés L3"
#define D_UV_INDEX_7 "tartományon kívül"
#define D_UV_LEVEL "UV szint"
#define D_UV_POWER "UV teljesítmény"
#define D_VERSION "Verzió"
#define D_VOLTAGE "Feszültség"
#define D_VOLUME "Volume"
#define D_WEIGHT "Tömeg"
#define D_WARMLIGHT "Meleg fény"
#define D_WEB_SERVER "Webszerver"

// tasmota.ino
#define D_WARNING_MINIMAL_VERSION "VIGYÁZZ! Ez a verzió nem támogat tartós beállításokat"
#define D_LEVEL_10 "szint 1-0"
#define D_LEVEL_01 "szint 0-1"
#define D_SERIAL_LOGGING_DISABLED "Soros naplózás kikapcsolva"
#define D_SYSLOG_LOGGING_REENABLED "Syslog logolás újraengedélyezve"

#define D_SET_BAUDRATE_TO "Baudrate beállítása"
#define D_RECEIVED_TOPIC "Érkezett topic"
#define D_DATA_SIZE "Adatméret"
#define D_ANALOG_INPUT "Analóg"

// support.ino
#define D_OSWATCH "osWatch"
#define D_BLOCKED_LOOP "Tiltott hurok"
#define D_WPS_FAILED_WITH_STATUS "WPSconfig SIKERTELEN státusz:"
#define D_ACTIVE_FOR_3_MINUTES "aktválás 3 percre"
#define D_FAILED_TO_START "sikertelen indítás"
#define D_PATCH_ISSUE_2186 "Patch issue 2186"
#define D_CONNECTING_TO_AP "AP-hoz csatlakozás:"
#define D_IN_MODE "mód:"
#define D_CONNECT_FAILED_NO_IP_ADDRESS "Sikertelen csatlakozás, nincs kiosztott IP cím"
#define D_CONNECT_FAILED_AP_NOT_REACHED "Sikertelen csatlakozás, AP nem elérhető"
#define D_CONNECT_FAILED_WRONG_PASSWORD "Sikertelen csatlakozás"
#define D_CONNECT_FAILED_AP_TIMEOUT "Sikertelen csatlakozás AP időtúllépés miatt"
#define D_ATTEMPTING_CONNECTION "Csatlakozás..."
#define D_CHECKING_CONNECTION "Kapcsolat ellenőrzése..."
#define D_QUERY_DONE "Lekérés kész. MQTT szolgáltatás aktív"
#define D_MQTT_SERVICE_FOUND "élő MQTT szolgáltatás a(z)"
#define D_FOUND_AT "a(z)"
#define D_SYSLOG_HOST_NOT_FOUND "Syslog hoszt nem található"

// settings.ino
#define D_SAVED_TO_FLASH_AT "Flash-re mentve a(z)"
#define D_LOADED_FROM_FLASH_AT "Flash-ről betöltve a(z)"
#define D_USE_DEFAULTS "Alapértelmezett beáll. használata"
#define D_ERASED_SECTOR "Szektor törlése"

// xdrv_02_webserver.ino
#define D_NOSCRIPT "A Tasmota használatához engedélyezd a Javascriptet!"
#define D_MINIMAL_FIRMWARE_PLEASE_UPGRADE "MINIMÁLIS firmware<br>frissítsd!"
#define D_WEBSERVER_ACTIVE_ON "Webszerver aktív:"
#define D_WITH_IP_ADDRESS "IP cím:"
#define D_WEBSERVER_STOPPED "Webszerver leállítva"
#define D_FILE_NOT_FOUND "Fájl nem található"
#define D_REDIRECTED "Átírányítás captive portálra"
#define D_WIFIMANAGER_SET_ACCESSPOINT_AND_STATION "WifiManager AccessPoint(AP) és Station(ST) beállítása"
#define D_WIFIMANAGER_SET_ACCESSPOINT "Wifimanager AccessPoint(AP) beállítása"
#define D_TRYING_TO_CONNECT "Csatlakozás a hálózatra..."

#define D_RESTART_IN "Újraindítás..."
#define D_SECONDS "másodperc"
#define D_DEVICE_WILL_RESTART "Az eszköz hamarosan újraindul..."
#define D_BUTTON_TOGGLE "Megfordítás"
#define D_CONFIGURATION "Beállítások"
#define D_INFORMATION "Információ"
#define D_FIRMWARE_UPGRADE "Firmware frissítés"
#define D_MANAGEMENT "Consoles"
#define D_CONSOLE "Konzol"
#define D_CONFIRM_RESTART "Biztosan újraindítsam a modult?"

#define D_CONFIGURE_MODULE "Eszközbeállítások"
#define D_CONFIGURE_WIFI "WiFi konfiguráció"
#define D_CONFIGURE_MQTT "MQTT konfiguráció"
#define D_CONFIGURE_DOMOTICZ "Domoticz konfiguráció"
#define D_CONFIGURE_LOGGING "Naplózás beállításai"
#define D_CONFIGURE_OTHER "Egyéb beállítások"
#define D_CONFIRM_RESET_CONFIGURATION "Biztosan töröljem a beállításokat?"
#define D_RESET_CONFIGURATION "Beállítások törlése"
#define D_BACKUP_CONFIGURATION "Beállítások mentése"
#define D_RESTORE_CONFIGURATION "Beállítások visszatöltése"
#define D_MAIN_MENU "Menü"

#define D_MODULE_PARAMETERS "Modul paraméterek"
#define D_MODULE_TYPE "Alkalmazott modul"
#define D_PULLUP_ENABLE "Nincs felhúzó ellenállás"
#define D_ADC "ADC"
#define D_GPIO "GPIO"
#define D_SERIAL_IN "Soros BE"
#define D_SERIAL_OUT "Soros KI"

#define D_WIFI_PARAMETERS "WiFi paraméterek"
#define D_SCAN_FOR_WIFI_NETWORKS "WiFi hálózat keresése"
#define D_SCAN_DONE "Keresés kész"
#define D_NO_NETWORKS_FOUND "Nincs elérhető hálózat"
#define D_REFRESH_TO_SCAN_AGAIN "Frissíts az újrakereséshez"
#define D_DUPLICATE_ACCESSPOINT "Duplikált access point"
#define D_SKIPPING_LOW_QUALITY "Rossz, alacsony jelminőség"
#define D_RSSI "RSSI"
#define D_WEP "WEP"
#define D_WPA_PSK "WPA PSK"
#define D_WPA2_PSK "WPA2 PSK"
#define D_AP1_SSID "WiFi Network"
#define D_AP1_SSID_HELP "Type or Select your WiFi Network"
#define D_AP2_SSID "WiFi Network 2"
#define D_AP2_SSID_HELP "Type your Alternative WiFi Network"
#define D_AP_PASSWORD "WiFi megosztott kulcs"
#define D_AP_PASSWORD_HELP "Enter your WiFi Password"
#define D_SELECT_YOUR_WIFI_NETWORK "Select your WiFi Network"
#define D_SHOW_MORE_WIFI_NETWORKS "Scan for all WiFi Networks"
#define D_SHOW_MORE_OPTIONS "More Options"
#define D_CHECK_CREDENTIALS "Please, check your credentials"
#define D_SUCCESSFUL_WIFI_CONNECTION "Successful WiFi Connection"
#define D_NOW_YOU_CAN_CLOSE_THIS_WINDOW "Now you can close this window"
#define D_REDIRECTING_TO_NEW_IP "Redirecting to new device's IP address"

#define D_MQTT_PARAMETERS "MQTT paraméterek"
#define D_CLIENT "Kliens"
#define D_FULL_TOPIC "Teljes topic"

#define D_LOGGING_PARAMETERS "Naplózási paraméterek"
#define D_SERIAL_LOG_LEVEL "Soros naplózási szint"
#define D_MQTT_LOG_LEVEL "Mqtt log level"
#define D_WEB_LOG_LEVEL "Web naplózási szint"
#define D_SYS_LOG_LEVEL "Syslog szint"
#define D_MORE_DEBUG "Részletes hibakeresés"
#define D_SYSLOG_HOST "Syslog hoszt"
#define D_SYSLOG_PORT "Syslog port"
#define D_TELEMETRY_PERIOD "Telemetria (mp.)"

#define D_OTHER_PARAMETERS "Egyéb beállítások"
#define D_TEMPLATE "Template"
#define D_ACTIVATE "Aktiválás"
#define D_DEVICE_NAME "Eszköz neve"
#define D_WEB_ADMIN_PASSWORD "Web admin jelszó"
#define D_MQTT_ENABLE "MQTT engedélyezése"
#define D_MQTT_TLS_ENABLE "MQTT TLS"
#define D_FRIENDLY_NAME "Név"
#define D_BELKIN_WEMO "Belkin WeMo"
#define D_HUE_BRIDGE "Hue Bridge"
#define D_SINGLE_DEVICE "single device"
#define D_MULTI_DEVICE "multi device"

#define D_CONFIGURE_TEMPLATE "Template beállítása"
#define D_TEMPLATE_PARAMETERS "Template paraméterek"
#define D_TEMPLATE_NAME "Név"
#define D_BASE_TYPE "Alapul ezen"
#define D_TEMPLATE_FLAGS "Opciók"

#define D_SAVE_CONFIGURATION "Beállítások mentése"
#define D_CONFIGURATION_SAVED "Beállítások elmentve"
#define D_CONFIGURATION_RESET "Beállítások visszaállítása"

#define D_PROGRAM_VERSION "Program verzió"
#define D_BUILD_DATE_AND_TIME "Build ideje"
#define D_CORE_AND_SDK_VERSION "Core/SDK verzió"
#define D_FLASH_WRITE_COUNT "Flash írások száma"
#define D_MAC_ADDRESS "MAC cím"
#define D_MQTT_HOST "MQTT hoszt"
#define D_MQTT_PORT "MQTT port"
#define D_MQTT_CLIENT "MQTT kliens"
#define D_MQTT_USER "MQTT felhasználó"
#define D_MQTT_TOPIC "MQTT topic"
#define D_MQTT_GROUP_TOPIC "MQTT csoport topic"
#define D_MQTT_FULL_TOPIC "MQTT teljes topic"
#define D_MQTT_NO_RETAIN "MQTT No Retain"
#define D_MDNS_DISCOVERY "mDNS láthatóság"
#define D_MDNS_ADVERTISE "mDNS hirdetés"
#define D_ESP_CHIP_ID "ESP chip ID"
#define D_FLASH_CHIP_ID "Flash chip ID"
#define D_FLASH_CHIP_SIZE "Flash mérete"
#define D_FREE_PROGRAM_SPACE "Szabad programhely"

#define D_UPGRADE_BY_WEBSERVER "Frissítés távoli szerverről"
#define D_OTA_URL "OTA URL"
#define D_START_UPGRADE "Frissítés"
#define D_UPGRADE_BY_FILE_UPLOAD "Frissítés helyi fájllal"
#define D_UPLOAD_STARTED "Feltöltés elindítva"
#define D_UPGRADE_STARTED "Frissítés elindítva"
#define D_UPLOAD_DONE "Feltöltés kész"
#define D_UPLOAD_TRANSFER "Upload transfer"
#define D_TRANSFER_STARTED "Transfer started"
#define D_UPLOAD_ERR_1 "Nincs fájl kijelölve"
#define D_UPLOAD_ERR_2 "Nincs elég memória"
#define D_UPLOAD_ERR_3 "Invalid file signature"
#define D_UPLOAD_ERR_4 "A program flashméret nagyobb a valós flashméretnél"
#define D_UPLOAD_ERR_5 "Feltöltési buffer hiba"
#define D_UPLOAD_ERR_6 "Feltöltés sikertelen. Endegélyezd a 3. szintű naplózást"
#define D_UPLOAD_ERR_7 "Feltöltés megszakítva"
#define D_UPLOAD_ERR_8 "Érvénytelen fájl"
#define D_UPLOAD_ERR_9 "A fájl túl nagy"
#define D_UPLOAD_ERR_10 "Az RF chip inicializálása sikertelen"
#define D_UPLOAD_ERR_11 "Az RF chip törlése sikertelen"
#define D_UPLOAD_ERR_12 "Az RF chip írása sikertelen"
#define D_UPLOAD_ERR_13 "Az RF firmware dekódolása sikertelen"
#define D_UPLOAD_ERR_14 "Nem kompatibilis"
#define D_UPLOAD_ERROR_CODE "Feltöltési hibakód"

#define D_ENTER_COMMAND "Kérem a parancsot..."
#define D_ENABLE_WEBLOG_FOR_RESPONSE "Engedélyezz 2-es szintű webnaplózást több információért"
#define D_NEED_USER_AND_PASSWORD "Szükséges a user=<felhasználónév>&password=<jelszó> paraméter"

// xdrv_01_mqtt.ino
#define D_FINGERPRINT "TLS fingerprint hitelesítése..."
#define D_TLS_CONNECT_FAILED_TO "TLS csatlakozás sikertelen a(z)"
#define D_RETRY_IN "Újrapróbálás"
#define D_VERIFIED "Fingerprint hitelesítve"
#define D_INSECURE "Nem biztonságos kapcsolat érvénytelen fingerprint miatt"
#define D_CONNECT_FAILED_TO "Sikertelen csatlakozás a(z)"

// xplg_wemohue.ino
#define D_MULTICAST_DISABLED "Multicast kikapcsolva"
#define D_MULTICAST_REJOINED "Multicast (újra)csatlakozás"
#define D_MULTICAST_JOIN_FAILED "Multicast csatlakozás sikertelen"
#define D_FAILED_TO_SEND_RESPONSE "Nem sikerült választ küldeni"

#define D_WEMO "WeMo"
#define D_WEMO_BASIC_EVENT "WeMo basic event"
#define D_WEMO_EVENT_SERVICE "WeMo event service"
#define D_WEMO_META_SERVICE "WeMo meta service"
#define D_WEMO_SETUP "WeMo beállítás"
#define D_RESPONSE_SENT "Válasz elküldve"

#define D_HUE "Hue"
#define D_HUE_BRIDGE_SETUP "Hue beállítás"
#define D_HUE_API_NOT_IMPLEMENTED "Hue API nincs implementálva"
#define D_HUE_API "Hue API"
#define D_HUE_POST_ARGS "Hue POST argumentumok"
#define D_3_RESPONSE_PACKETS_SENT "3 válaszcsomag elküldve"

// xdrv_07_domoticz.ino
#define D_DOMOTICZ_PARAMETERS "Domoticz paraméterek"
#define D_DOMOTICZ_IDX "Idx"
#define D_DOMOTICZ_KEY_IDX "Key idx"
#define D_DOMOTICZ_SWITCH_IDX "Kapcsoló idx"
#define D_DOMOTICZ_SENSOR_IDX "Szenzor idx"
  #define D_DOMOTICZ_TEMP "Hőmérséklet"
  #define D_DOMOTICZ_TEMP_HUM "Hőmérséklet, páratartalom"
  #define D_DOMOTICZ_TEMP_HUM_BARO "Hőmérséklet, páratartalom, légnyomás"
  #define D_DOMOTICZ_POWER_ENERGY "Teljesítmény, energia"
  #define D_DOMOTICZ_ILLUMINANCE "Fényerő"
  #define D_DOMOTICZ_COUNT "Szám/PM1"
  #define D_DOMOTICZ_VOLTAGE "Feszültség/PM2.5"
  #define D_DOMOTICZ_CURRENT "Áram/PM10"
  #define D_DOMOTICZ_AIRQUALITY "Légminőség"
  #define D_DOMOTICZ_P1_SMART_METER "P1SmartMeter"
#define D_DOMOTICZ_UPDATE_TIMER "Frissítési időzítő"

// xdrv_09_timers.ino
#define D_CONFIGURE_TIMER "Időzítő beállításai"
#define D_TIMER_PARAMETERS "Időzítő paraméterei"
#define D_TIMER_ENABLE "Időzítők engedélyezve"
#define D_TIMER_ARM "Be"
#define D_TIMER_TIME "Idő"
#define D_TIMER_DAYS "Napok"
#define D_TIMER_REPEAT "Ismétlés"
#define D_TIMER_OUTPUT "Kimenet"
#define D_TIMER_ACTION "Művelet"

// xdrv_10_knx.ino
#define D_CONFIGURE_KNX "KNX beállításai"
#define D_KNX_PARAMETERS "KNX paraméterei"
#define D_KNX_GENERAL_CONFIG "Általános"
#define D_KNX_PHYSICAL_ADDRESS "Fizikai cím"
#define D_KNX_PHYSICAL_ADDRESS_NOTE "(egyedinek kell lennie a KNX hálózaton)"
#define D_KNX_ENABLE "KNX engedélyezése"
#define D_KNX_GROUP_ADDRESS_TO_WRITE "Íráshoz használt csoportcímek"
#define D_ADD "Hozzáadás"
#define D_DELETE "Törlés"
#define D_REPLY "Válasz"
#define D_KNX_GROUP_ADDRESS_TO_READ "Fogadáshoz használt csoportcímek"
#define D_RECEIVED_FROM "Fogadva tőle:"
#define D_KNX_COMMAND_WRITE "Írás"
#define D_KNX_COMMAND_READ "Olvasás"
#define D_KNX_COMMAND_OTHER "Egyáb"
#define D_SENT_TO "küldve neki:"
#define D_KNX_WARNING "A csoportcím ( 0 / 0 / 0 ) fenntartott és nem használható."
#define D_KNX_ENHANCEMENT "Communication Enhancement"
#define D_KNX_TX_SLOT "KNX TX"
#define D_KNX_RX_SLOT "KNX RX"
#define D_KNX_TX_SCENE "KNX SCENE TX"
#define D_KNX_RX_SCENE "KNX SCENE RX"

// xdrv_23_zigbee
#define D_ZIGBEE_PERMITJOIN_ACTIVE "Eszközök kapcsolódhatnak"
#define D_ZIGBEE_MAPPING_TITLE "Tasmota Zigbee leképezés"
#define D_ZIGBEE_NOT_STARTED "Zigbee nincs elindítva"
#define D_ZIGBEE_MAPPING_IN_PROGRESS_SEC "Leképezés folyamatban (%d mp. van hátra)"
#define D_ZIGBEE_MAPPING_NOT_PRESENT "Nincs leképezés"
#define D_ZIGBEE_MAP_REFRESH "Zigbee térkép frissítés"
#define D_ZIGBEE_MAP   "Zigbee térkép"
#define D_ZIGBEE_PERMITJOIN "Zigbee kapcsolódási engedély"
#define D_ZIGBEE_GENERATE_KEY "véletlen Zigbee hálózati kulcs generálása"
#define D_ZIGBEE_UNKNOWN_DEVICE "Ismeretlen eszköz"
#define D_ZIGBEE_UNKNOWN_ATTRIBUTE "Ismeretlen tulajdonság"
#define D_ZIGBEE_INVALID_PARAM "Érvénytelen paraméter"
#define D_ZIGBEE_MISSING_PARAM "Hiányzó paraméter(ek)"
#define D_ZIGBEE_UNKNWON_ATTRIBUTE "Ismeretlen tulajdonság név (kihagyva): %s"
#define D_ZIGBEE_TOO_MANY_CLUSTERS "Egynél több klaszter id nem lehet parancsonként"
#define D_ZIGBEE_WRONG_DELIMITER "Hibás adatcsomag elválasztó"
#define D_ZIGBEE_UNRECOGNIZED_COMMAND "Nem értelmezhető Zigbee parancs: %s"
#define D_ZIGBEE_TOO_MANY_COMMANDS "Csak egy parancs engedélyezett (%d)"
#define D_ZIGBEE_NO_ATTRIBUTE "A tulajdonság nincs a listában"
#define D_ZIGBEE_UNSUPPORTED_ATTRIBUTE_TYPE "Nem támogatott tulajdonság típus"
#define D_ZIGBEE_JSON_REQUIRED "Beállítás JSON objektumot vár"
#define D_ZIGBEE_RESET_1_OR_2 "1 vagy 2 a visszaállításhoz"
#define D_ZIGBEE_EEPROM_FOUND_AT_ADDRESS "ZBBridge EEPROM található a címen"
#define D_ZIGBEE_RANDOMIZING_ZBCONFIG "Zigbee paramétereknek véletlennek kell lenniük, ellenőrizd a 'ZbConfig'-gal"

// xdrv_03_energy.ino
#define D_ENERGY_TODAY "Mai energia"
#define D_ENERGY_YESTERDAY "Tegnapi energia"
#define D_ENERGY_TOTAL "Összes energia"

// xdrv_27_shutter.ino
#define D_OPEN "Nyitva"
#define D_CLOSE "Zárva"
#define D_DOMOTICZ_SHUTTER "Redőny"

// xdrv_28_pcf8574.ino
#define D_CONFIGURE_PCF8574 "PCF8574 beállítása"
#define D_PCF8574_PARAMETERS "PCF8574 paraméterei"
#define D_INVERT_PORTS "Inverz portok"
#define D_DEVICE "Eszköz"
#define D_DEVICE_INPUT "Bemenet"
#define D_DEVICE_OUTPUT "Kimenet"

// xsns_05_ds18b20.ino
#define D_SENSOR_BUSY "Szenzor foglalt"
#define D_SENSOR_CRC_ERROR "Szenzor CRC hiba"
#define D_SENSORS_FOUND "Szenzorok megtalálva"

// xsns_06_dht.ino
#define D_TIMEOUT_WAITING_FOR "Időtúllépés, várakozás"
#define D_START_SIGNAL_LOW "startjel alacsony"
#define D_START_SIGNAL_HIGH "startjel magas"
#define D_PULSE "impulzus"
#define D_CHECKSUM_FAILURE "Checksum hiba"

// xsns_07_sht1x.ino
#define D_SENSOR_DID_NOT_ACK_COMMAND "A szenzor nem nyugtázta a parancsot"
#define D_SHT1X_FOUND "SHT1X megtalálva"

// xsns_18_pms5003.ino
#define D_STANDARD_CONCENTRATION "CF-1 PM"     // Standard Particle CF-1 Particle Matter
#define D_ENVIRONMENTAL_CONCENTRATION "PM"     // Environmetal Particle Matter
#define D_PARTICALS_BEYOND "Részecskék"

// xsns_27_apds9960.ino
#define D_GESTURE "Gesztus"
#define D_COLOR_RED "Piros (R)"
#define D_COLOR_GREEN "Zöld (G)"
#define D_COLOR_BLUE "Kék (B)"
#define D_CCT "CCT"
#define D_PROXIMITY "közelség"

// xsns_32_mpu6050.ino
#define D_AX_AXIS "Gyorsulásm. X-tengely"
#define D_AY_AXIS "Gyorsulásm. Y-tengely"
#define D_AZ_AXIS "Gyorsulásm. Z-tengely"
#define D_GX_AXIS "Giroszkóp X-tengely"
#define D_GY_AXIS "Giroszkóp Y-tengely"
#define D_GZ_AXIS "Giroszkóp Z-tengely"

// xsns_34_hx711.ino
#define D_HX_CAL_REMOVE "Távolítsa el a súlyt"
#define D_HX_CAL_REFERENCE "Helyezze fel a referenciasúlyt"
#define D_HX_CAL_DONE "Kalibrálva"
#define D_HX_CAL_FAIL "Kalibrálási hiba"
#define D_RESET_HX711 "Skála újrabeállítása"
#define D_CONFIGURE_HX711 "Skála konfigurálása"
#define D_HX711_PARAMETERS "Skálaparaméterek"
#define D_ITEM_WEIGHT "Tárgy tömege"
#define D_REFERENCE_WEIGHT "Referenciatömeg"
#define D_CALIBRATE "Kalibrálás"
#define D_CALIBRATION "Kalibrálás"

//xsns_35_tx20.ino
#define D_TX20_WIND_DIRECTION "Szélirány"
#define D_TX20_WIND_SPEED "Szélsebesség"
#define D_TX20_WIND_SPEED_MIN "Min. szélsebesség"
#define D_TX20_WIND_SPEED_MAX "Max. szélsebesség"
#define D_TX20_NORTH "É"
#define D_TX20_EAST "K"
#define D_TX20_SOUTH "D"
#define D_TX20_WEST "NY"

// xsns_53_sml.ino
#define D_TPWRIN "Összes bejövő energia"
#define D_TPWROUT "Összes kimenő energia"
#define D_TPWRCURR "Aktív teljesítmény Be/Ki"
#define D_TPWRCURR1 "Aktív teljesítmény-Be p1"
#define D_TPWRCURR2 "Aktív teljesítmény-Be p2"
#define D_TPWRCURR3 "Aktív teljesítmény-Be p3"
#define D_Strom_L1 "Áramerősség L1"
#define D_Strom_L2 "Áramerősség L2"
#define D_Strom_L3 "Áramerősség L3"
#define D_Spannung_L1 "Feszültség L1"
#define D_Spannung_L2 "Feszültség L2"
#define D_Spannung_L3 "Feszültség L3"
#define D_METERNR "Meter_number"
#define D_METERSID "Service ID"
#define D_GasIN "Számláló"
#define D_H2oIN "Számláló"
#define D_StL1L2L3 "Áramerősség L1+L2+L3"
#define D_SpL1L2L3 "Feszültség L1+L2+L3/3"

// xsns_86_tfminiplus.ino
#define D_SIGNALSTRENGTH "Signal Strength"
#define D_CHIPTEMPERATURE "Chip Temperature"

// tasmota_template.h - keep them as short as possible to be able to fit them in GUI drop down box
#define D_SENSOR_NONE          "Nincs"
#define D_SENSOR_USER          "User"
#define D_SENSOR_OPTION        "Option"
#define D_SENSOR_DHT11         "DHT11"
#define D_SENSOR_AM2301        "AM2301"
#define D_SENSOR_SI7021        "SI7021"
#define D_SENSOR_DS18X20       "DS18x20"
#define D_SENSOR_I2C_SCL       "I2C SCL"
#define D_SENSOR_I2C_SDA       "I2C SDA"
#define D_SENSOR_WS2812        "WS2812"
#define D_SENSOR_DFR562        "MP3 lejátszó"
#define D_SENSOR_IRSEND        "IR adó"
#define D_SENSOR_SWITCH        "Kapcsoló"   // Suffix "1"
#define D_SENSOR_BUTTON        "Gomb"       // Suffix "1"
#define D_SENSOR_RELAY         "Relé"       // Suffix "1i"
#define D_SENSOR_LED           "LED"        // Suffix "1i"
#define D_SENSOR_LED_LINK      "LedLink"    // Suffix "i"
#define D_SENSOR_PWM           "PWM"        // Suffix "1"
#define D_SENSOR_COUNTER       "Számláló"   // Suffix "1"
#define D_SENSOR_INPUT         "Input"
#define D_SENSOR_IRRECV        "IR vevő"
#define D_SENSOR_MHZ_RX        "MHZ Rx"
#define D_SENSOR_MHZ_TX        "MHZ Tx"
#define D_SENSOR_PZEM004_RX    "PZEM004 Rx"
#define D_SENSOR_PZEM016_RX    "PZEM016 Rx"
#define D_SENSOR_PZEM017_RX    "PZEM017 Rx"
#define D_SENSOR_PZEM0XX_TX    "PZEM0XX Tx"
#define D_SENSOR_SAIR_RX       "SAir Rx"
#define D_SENSOR_SAIR_TX       "SAir Tx"
#define D_SENSOR_SPI_CS        "SPI CS"
#define D_SENSOR_SPI_DC        "SPI DC"
#define D_SENSOR_SPI_MISO      "SPI MISO"
#define D_SENSOR_SPI_MOSI      "SPI MOSI"
#define D_SENSOR_SPI_CLK       "SPI CLK"
#define D_SENSOR_BACKLIGHT     "Háttérfény"
#define D_SENSOR_PMS5003_TX    "PMS5003 Tx"
#define D_SENSOR_PMS5003_RX    "PMS5003 Rx"
#define D_SENSOR_SDS0X1_RX     "SDS0X1 Rx"
#define D_SENSOR_SDS0X1_TX     "SDS0X1 Tx"
#define D_SENSOR_HPMA_RX       "HPMA Rx"
#define D_SENSOR_HPMA_TX       "HPMA Tx"
#define D_SENSOR_SBR_RX        "SerBr Rx"
#define D_SENSOR_SBR_TX        "SerBr Tx"
#define D_SENSOR_SR04_TRIG     "SR04 Tri/TX"
#define D_SENSOR_SR04_ECHO     "SR04 Ech/RX"
#define D_SENSOR_SDM72_TX      "SDM72 Tx"
#define D_SENSOR_SDM72_RX      "SDM72 Rx"
#define D_SENSOR_SDM120_TX     "SDMx20 Tx"
#define D_SENSOR_SDM120_RX     "SDMx20 Rx"
#define D_SENSOR_SDM630_TX     "SDM630 Tx"
#define D_SENSOR_SDM630_RX     "SDM630 Rx"
#define D_SENSOR_WE517_TX      "WE517 Tx"
#define D_SENSOR_WE517_RX      "WE517 Rx"
#define D_SENSOR_TM1637_CLK    "TM1637 CLK"
#define D_SENSOR_TM1637_DIO    "TM1637 DIO"
#define D_SENSOR_TM1638_CLK    "TM1638 CLK"
#define D_SENSOR_TM1638_DIO    "TM1638 DIO"
#define D_SENSOR_TM1638_STB    "TM1638 STB"
#define D_SENSOR_MAX7219_DIN    "MAX7219 DIN"
#define D_SENSOR_MAX7219_CS    "MAX7219 CS"
#define D_SENSOR_MAX7219_CLK    "MAX7219 CLK"
#define D_SENSOR_HX711_SCK     "HX711 SCK"
#define D_SENSOR_HX711_DAT     "HX711 DAT"
#define D_SENSOR_FTC532        "FTC532"
#define D_SENSOR_BS814_CLK     "BS814 CLK"
#define D_SENSOR_BS814_DAT     "BS814 DAT"
#define D_SENSOR_TX2X_TX       "TX2x"
#define D_SENSOR_RFSEND        "RFSend"
#define D_SENSOR_RFRECV        "RFrecv"
#define D_SENSOR_TUYA_TX       "Tuya Tx"
#define D_SENSOR_TUYA_RX       "Tuya Rx"
#define D_SENSOR_MGC3130_XFER  "MGC3130 Xfr"
#define D_SENSOR_MGC3130_RESET "MGC3130 Rst"
#define D_SENSOR_SSPI_MISO     "SSPI MISO"
#define D_SENSOR_SSPI_MOSI     "SSPI MOSI"
#define D_SENSOR_SSPI_SCLK     "SSPI SCLK"
#define D_SENSOR_SSPI_CS       "SSPI CS"
#define D_SENSOR_SSPI_DC       "SSPI DC"
#define D_SENSOR_RF_SENSOR     "RF Sensor"
#define D_SENSOR_AZ_RX         "AZ Rx"
#define D_SENSOR_AZ_TX         "AZ Tx"
#define D_SENSOR_MAX31855_CS   "MX31855 CS"
#define D_SENSOR_MAX31855_CLK  "MX31855 CLK"
#define D_SENSOR_MAX31855_DO   "MX31855 DO"
#define D_SENSOR_MAX31865_CS   "MX31865 CS"
#define D_SENSOR_NRG_SEL       "HLWBL SEL"  // Suffix "i"
#define D_SENSOR_NRG_CF1       "HLWBL CF1"
#define D_SENSOR_HLW_CF        "HLW8012 CF"
#define D_SENSOR_HJL_CF        "BL0937 CF"
#define D_SENSOR_MCP39F5_TX    "MCP39F5 Tx"
#define D_SENSOR_MCP39F5_RX    "MCP39F5 Rx"
#define D_SENSOR_MCP39F5_RST   "MCP39F5 Rst"
#define D_SENSOR_CSE7761_TX    "CSE7761 Tx"
#define D_SENSOR_CSE7761_RX    "CSE7761 Rx"
#define D_SENSOR_CSE7766_TX    "CSE7766 Tx"
#define D_SENSOR_CSE7766_RX    "CSE7766 Rx"
#define D_SENSOR_PN532_TX      "PN532 Tx"
#define D_SENSOR_PN532_RX      "PN532 Rx"
#define D_SENSOR_SM16716_CLK   "SM16716 CLK"
#define D_SENSOR_SM16716_DAT   "SM16716 DAT"
#define D_SENSOR_SM16716_POWER "SM16716 PWR"
#define D_SENSOR_P9813_CLK     "P9813 Clk"
#define D_SENSOR_P9813_DAT     "P9813 Dat"
#define D_SENSOR_MY92X1_DI     "MY92x1 DI"
#define D_SENSOR_MY92X1_DCKI   "MY92x1 DCKI"
#define D_SENSOR_ARIRFRCV      "ALux IrRcv"
#define D_SENSOR_ARIRFSEL      "ALux IrSel"
#define D_SENSOR_TXD           "Serial Tx"
#define D_SENSOR_RXD           "Serial Rx"
#define D_SENSOR_ROTARY        "Rotary"     // Suffix "1A"
#define D_SENSOR_HRE_CLOCK     "HRE Clock"
#define D_SENSOR_HRE_DATA      "HRE Data"
#define D_SENSOR_ADE7953_IRQ   "ADE7953 IRQ"
#define D_SENSOR_BUZZER        "Buzzer"
#define D_SENSOR_OLED_RESET    "OLED Reset"
#define D_SENSOR_ZIGBEE_TXD    "Zigbee Tx"
#define D_SENSOR_ZIGBEE_RXD    "Zigbee Rx"
#define D_SENSOR_ZIGBEE_RST    "Zigbee Rst"
#define D_SENSOR_SOLAXX1_TX    "SolaxX1 Tx"
#define D_SENSOR_SOLAXX1_RX    "SolaxX1 Rx"
#define D_SENSOR_IBEACON_TX    "iBeacon TX"
#define D_SENSOR_IBEACON_RX    "iBeacon RX"
#define D_SENSOR_RDM6300_RX    "RDM6300 RX"
#define D_SENSOR_CC1101_CS     "CC1101 CS"
#define D_SENSOR_A4988_DIR     "A4988 DIR"
#define D_SENSOR_A4988_STP     "A4988 STP"
#define D_SENSOR_A4988_ENA     "A4988 ENA"
#define D_SENSOR_A4988_MS1     "A4988 MS1"
#define D_SENSOR_OUTPUT_HI     "Output Hi"
#define D_SENSOR_OUTPUT_LO     "Output Lo"
#define D_SENSOR_AS608_TX      "AS608 Tx"
#define D_SENSOR_AS608_RX      "AS608 Rx"
#define D_SENSOR_DDS2382_TX    "DDS238-2 Tx"
#define D_SENSOR_DDS2382_RX    "DDS238-2 Rx"
#define D_SENSOR_DDSU666_TX    "DDSU666 Tx"
#define D_SENSOR_DDSU666_RX    "DDSU666 Rx"
#define D_SENSOR_SM2135_CLK    "SM2135 Clk"
#define D_SENSOR_SM2135_DAT    "SM2135 Dat"
#define D_SENSOR_DEEPSLEEP     "DeepSleep"
#define D_SENSOR_EXS_ENABLE    "EXS Enable"
#define D_SENSOR_CLIENT_TX    "Client TX"
#define D_SENSOR_CLIENT_RX    "Client RX"
#define D_SENSOR_CLIENT_RESET "Client RST"
#define D_SENSOR_GPS_RX        "GPS RX"
#define D_SENSOR_GPS_TX        "GPS TX"
#define D_SENSOR_HM10_RX       "HM10 RX"
#define D_SENSOR_HM10_TX       "HM10 TX"
#define D_SENSOR_LE01MR_RX     "LE-01MR Rx"
#define D_SENSOR_LE01MR_TX     "LE-01MR Tx"
#define D_SENSOR_BL0940_RX     "BL0940 Rx"
#define D_SENSOR_CC1101_GDO0   "CC1101 GDO0"
#define D_SENSOR_CC1101_GDO2   "CC1101 GDO2"
#define D_SENSOR_HRXL_RX       "HRXL Rx"
#define D_SENSOR_DYP_RX        "DYP Rx"
#define D_SENSOR_ELECTRIQ_MOODL "MOODL Tx"
#define D_SENSOR_AS3935        "AS3935"
#define D_SENSOR_WINDMETER_SPEED "WindMeter Spd"
#define D_SENSOR_TELEINFO_RX   "TInfo Rx"
#define D_SENSOR_TELEINFO_ENABLE "TInfo EN"
#define D_SENSOR_LMT01_PULSE   "LMT01 Pulse"
#define D_SENSOR_ADC_INPUT     "ADC Input"
#define D_SENSOR_ADC_TEMP      "ADC Temp"
#define D_SENSOR_ADC_LIGHT     "ADC Light"
#define D_SENSOR_ADC_BUTTON    "ADC Button"
#define D_SENSOR_ADC_RANGE     "ADC Range"
#define D_SENSOR_ADC_CT_POWER  "ADC CT Power"
#define D_SENSOR_ADC_JOYSTICK  "ADC Joystick"
#define D_SENSOR_ADC_PH        "ADC pH"
#define D_GPIO_WEBCAM_PWDN     "CAM_PWDN"
#define D_GPIO_WEBCAM_RESET    "CAM_RESET"
#define D_GPIO_WEBCAM_XCLK     "CAM_XCLK"
#define D_GPIO_WEBCAM_SIOD     "CAM_SIOD"
#define D_GPIO_WEBCAM_SIOC     "CAM_SIOC"
#define D_GPIO_WEBCAM_DATA     "CAM_DATA"
#define D_GPIO_WEBCAM_VSYNC    "CAM_VSYNC"
#define D_GPIO_WEBCAM_HREF     "CAM_HREF"
#define D_GPIO_WEBCAM_PCLK     "CAM_PCLK"
#define D_GPIO_WEBCAM_PSCLK    "CAM_PSCLK"
#define D_GPIO_WEBCAM_HSD      "CAM_HSD"
#define D_GPIO_WEBCAM_PSRCS    "CAM_PSRCS"
#define D_SENSOR_ETH_PHY_POWER "ETH POWER"
#define D_SENSOR_ETH_PHY_MDC   "ETH MDC"
#define D_SENSOR_ETH_PHY_MDIO  "ETH MDIO"
#define D_SENSOR_TCP_TXD       "TCP Tx"
#define D_SENSOR_TCP_RXD       "TCP Rx"
#define D_SENSOR_IEM3000_TX    "iEM3000 TX"
#define D_SENSOR_IEM3000_RX    "iEM3000 RX"
#define D_SENSOR_MIEL_HVAC_TX  "MiEl HVAC Tx"
#define D_SENSOR_MIEL_HVAC_RX  "MiEl HVAC Rx"
#define D_SENSOR_PROJECTOR_CTRL_TX  "DLP Tx"
#define D_SENSOR_PROJECTOR_CTRL_RX  "DLP Rx"
#define D_SENSOR_SHELLY_DIMMER_BOOT0 "SHD Boot 0"
#define D_SENSOR_SHELLY_DIMMER_RST_INV "SHD Reset"
#define D_SENSOR_RC522_RST     "RC522 Rst"
#define D_SENSOR_RC522_CS      "RC522 CS"
#define D_SENSOR_NRF24_CS      "NRF24 CS"
#define D_SENSOR_NRF24_DC      "NRF24 DC"
#define D_SENSOR_XPT2046_CS    "XPT2046 CS"
#define D_SENSOR_ILI9341_CS    "ILI9341 CS"
#define D_SENSOR_ILI9341_DC    "ILI9341 DC"
#define D_SENSOR_ILI9488_CS    "ILI9488 CS"
#define D_SENSOR_EPAPER29_CS   "EPaper29 CS"
#define D_SENSOR_EPAPER42_CS   "EPaper42 CS"
#define D_SENSOR_SSD1351_CS    "SSD1351 CS"
#define D_SENSOR_SSD1351_DC    "SSD1351 DC"
#define D_SENSOR_RA8876_CS     "RA8876 CS"
#define D_SENSOR_ST7789_CS     "ST7789 CS"
#define D_SENSOR_ST7789_DC     "ST7789 DC"
#define D_SENSOR_SSD1331_CS    "SSD1331 CS"
#define D_SENSOR_SSD1331_DC    "SSD1331 DC"
#define D_SENSOR_SDCARD_CS     "SDCard CS"
#define D_SENSOR_WIEGAND_D0    "Wiegand D0"
#define D_SENSOR_WIEGAND_D1    "Wiegand D1"
#define D_SENSOR_NEOPOOL_TX    "NeoPool Tx"
#define D_SENSOR_NEOPOOL_RX    "NeoPool Rx"
#define D_SENSOR_VL53L0X_XSHUT "VL53L0X XSHUT"
#define D_SENSOR_TFMINIPLUS_TX  "TFmini+ TX"
#define D_SENSOR_TFMINIPLUS_RX  "TFmini+ RX"
#define D_SENSOR_ZEROCROSS     "ZC Pulse"
#define D_SENSOR_HALLEFFECT    "HallEffect"
#define D_SENSOR_EPD_DATA      "EPD Data"

// Units
#define D_UNIT_AMPERE "A"
#define D_UNIT_CELSIUS "C"
#define D_UNIT_CENTIMETER "cm"
#define D_UNIT_DEGREE "°"
#define D_UNIT_FAHRENHEIT "F"
#define D_UNIT_HERTZ "Hz"
#define D_UNIT_HOUR "h"
#define D_UNIT_GALLONS "gal"
#define D_UNIT_GALLONS_PER_MIN "g/m"
#define D_UNIT_INCREMENTS "növ."
#define D_UNIT_KELVIN "K"
#define D_UNIT_KILOMETER "km"
#define D_UNIT_KILOGRAM "kg"
#define D_UNIT_KILOMETER_PER_HOUR "km/h"  // or "km/h"
#define D_UNIT_KILOOHM "kΩ"
#define D_UNIT_KILOWATTHOUR "kWh"
#define D_UNIT_LITERS "L"
#define D_UNIT_LITERS_PER_MIN "L/m"
#define D_UNIT_LUX "lx"
#define D_UNIT_MICROGRAM_PER_CUBIC_METER "µg/m³"
#define D_UNIT_MICROMETER "µm"
#define D_UNIT_MICROSECOND "µs"
#define D_UNIT_MICROSIEMENS_PER_CM "µS/cm"
#define D_UNIT_MILLIAMPERE "mA"
#define D_UNIT_MILLILITERS "ml"
#define D_UNIT_MILLIMETER "mm"
#define D_UNIT_MILLIMETER_MERCURY "mmHg"
#define D_UNIT_MILLISECOND "ms"
#define D_UNIT_MILLIVOLT "mV"
#define D_UNIT_MINUTE "min"
#define D_UNIT_PARTS_PER_BILLION "ppb"
#define D_UNIT_PARTS_PER_DECILITER "ppd"
#define D_UNIT_PARTS_PER_MILLION "ppm"
#define D_UNIT_MILIGRAMS_PER_LITER "mg/L"
#define D_UNIT_PERCENT "%%"
#define D_UNIT_PRESSURE "hPa"
#define D_UNIT_SECOND "s"
#define D_UNIT_SECTORS "szektorok"
#define D_UNIT_VA "VA"
#define D_UNIT_VAR "VAr"
#define D_UNIT_VOLT "V"
#define D_UNIT_WATT "W"
#define D_UNIT_WATTHOUR "Wh"
#define D_UNIT_WATT_METER_QUADRAT "W/m²"

#define D_NEW_ADDRESS          "Setting address to"
#define D_OUT_OF_RANGE         "Out of Range"
#define D_SENSOR_DETECTED      "detected"

//SDM220, SDM120, SDM72, LE01MR
#define D_EXPORT_POWER    "Export Power"
#define D_IMPORT_POWER 	  "Import Power"
#define D_PHASE_ANGLE     "Fázisszög"
#define D_IMPORT_ACTIVE   "Bejövő aktív"
#define D_EXPORT_ACTIVE   "Kimenő aktív"
#define D_IMPORT_REACTIVE "Bejövő reaktív"
#define D_EXPORT_REACTIVE "Kimenő reaktív"
#define D_TOTAL_REACTIVE  "Összes reaktív"
#define D_UNIT_KWARH      "kVArh"
#define D_UNIT_ANGLE      "fok"
#define D_TOTAL_ACTIVE    "Összes aktív"

//SOLAXX1
#define D_PV1_VOLTAGE     "PV1 feszültség"
#define D_PV1_CURRENT     "PV1 áramerősség"
#define D_PV1_POWER       "PV1 teljesítmény"
#define D_PV2_VOLTAGE     "PV2 feszültség"
#define D_PV2_CURRENT     "PV2 áramerősség"
#define D_PV2_POWER       "PV2 teljesítmény"
#define D_SOLAR_POWER     "Solar teljesítmény"
#define D_INVERTER_POWER  "Inverter teljesítmény"
#define D_STATUS          "Állapot"
#define D_WAITING         "Várakozás"
#define D_CHECKING        "Ellenőrzés"
#define D_WORKING         "Folyamatban"
#define D_FAILURE         "Hiba"
#define D_SOLAX_ERROR_0   "Nincs hibakód"
#define D_SOLAX_ERROR_1   "Hálózat elvesztése hiba"
#define D_SOLAX_ERROR_2   "Hálózat feszültség hiba"
#define D_SOLAX_ERROR_3   "Hálózat frekvencia hiba"
#define D_SOLAX_ERROR_4   "Pv feszültség hiba"
#define D_SOLAX_ERROR_5   "Elválasztási hiba"
#define D_SOLAX_ERROR_6   "Túlmelegedés hiba"
#define D_SOLAX_ERROR_7   "Ventillátor hiba"
#define D_SOLAX_ERROR_8   "Egyéb eszközhiba"

//xdrv_10_scripter.ino
#define D_CONFIGURE_SCRIPT     "Script szerkesztése"
#define D_SCRIPT               "script szerkesztése"
#define D_SDCARD_UPLOAD        "fájl feltöltés"
#define D_UFSDIR               "ufs mappa"
#define D_UPL_DONE             "Kész"
#define D_SCRIPT_CHARS_LEFT    "karakter még"
#define D_SCRIPT_CHARS_NO_MORE "nincs több karakter"
#define D_SCRIPT_DOWNLOAD      "Letöltés"
#define D_SCRIPT_ENABLE        "script engedélyezés"
#define D_SCRIPT_UPLOAD        "Feltöltés"
#define D_SCRIPT_UPLOAD_FILES  "Fájlok feltöltése"

//xdrv_50_filesystem.ino
#define D_MANAGE_FILE_SYSTEM   "Fájlrendszer kezelése"
#define D_FS_SIZE              "Méret"
#define D_FS_FREE              "Szabad"
#define D_NEW_FILE             "newfile.txt"
#define D_CREATE_NEW_FILE      "Create and edit new file"
#define D_EDIT_FILE            "Edit File"

//xsns_67_as3935.ino
#define D_AS3935_GAIN "nyereség:"
#define D_AS3935_ENERGY "enegia:"
#define D_AS3935_DISTANCE "távolság:"
#define D_AS3935_DISTURBER "zavaró:"
#define D_AS3935_VRMS "µVrms:"
#define D_AS3935_APRX "kb.:"
#define D_AS3935_AWAY "távol"
#define D_AS3935_LIGHT "villám"
#define D_AS3935_OUT "villám hatókörön kívül"
#define D_AS3935_NOT "távolság nem meghatározható"
#define D_AS3935_ABOVE "villám felül"
#define D_AS3935_NOISE "zaj érzékelve"
#define D_AS3935_DISTDET "zavarás érzékelve"
#define D_AS3935_INTNOEV "Megszakítás esemény nélkül!"
#define D_AS3935_FLICKER "IRQ zörgés!"
#define D_AS3935_POWEROFF "Kikapcsolva"
#define D_AS3935_NOMESS "hallgatózás..."
#define D_AS3935_ON "Be"
#define D_AS3935_OFF "Ki"
#define D_AS3935_INDOORS "Beltér"
#define D_AS3935_OUTDOORS "Kültér"
#define D_AS3935_CAL_FAIL "kalibráció nem sikerült"
#define D_AS3935_CAL_OK "kalibráció beállítva:"

//xsns_68_opentherm.ino
#define D_SENSOR_BOILER_OT_RX   "OpenTherm RX"
#define D_SENSOR_BOILER_OT_TX   "OpenTherm TX"

// xnrg_15_teleinfo Denky (Teleinfo)
#define D_CONTRACT        "Szerződés"
#define D_POWER_LOAD      "Teljesítény"
#define D_CURRENT_TARIFF  "Áramerősség díja"
#define D_TARIFF          "Díj"
#define D_OVERLOAD        "Túlterhelés"
#define D_MAX_POWER       "Max teljesítmény"
#define D_MAX_CURRENT     "Max áramerősség"

// xsns_79_as608.ino
#define D_FP_ENROLL_PLACEFINGER "Helyezze oda az ujját"
#define D_FP_ENROLL_REMOVEFINGER "Vegye el az ujját"
#define D_FP_ENROLL_PLACESAMEFINGER "Ugyanazt az ujját tegye oda ismét"
#define D_FP_ENROLL_RETRY "Hiba, próbálkozzon újra"
#define D_FP_ENROLL_RESTART "Újrindítás"
#define D_FP_ENROLL_ERROR "Hiba"
#define D_FP_ENROLL_RESET "Reset"
#define D_FP_ENROLL_ACTIVE "Aktív"
#define D_FP_ENROLL_INACTIVE "Inaktív"
// Indexed by Adafruit_Fingerprint.h defines
#define D_FP_PACKETRECIEVEERR "Komm. hiba"    // 0x01 Error when receiving data package
#define D_FP_NOFINGER ""                       // 0x02 No finger on the sensor
#define D_FP_IMAGEFAIL "Kép hiba"         // 0x03 Failed to enroll the finger
#define D_FP_IMAGEMESS "Túl zajos kép"       // 0x06 Failed to generate character file due to overly disorderly fingerprint image
#define D_FP_FEATUREFAIL "Ujjlenyomat túl kicsi" // 0x07 Failed to generate character file due to the lack of character point or small fingerprint image
#define D_FP_NOMATCH "Nincs találat"                // 0x08 Finger doesn't match
#define D_FP_NOTFOUND "Nincs találat"   // 0x09 Failed to find matching finger
#define D_FP_ENROLLMISMATCH "Nincs találat" // 0x0A Failed to combine the character files
#define D_FP_BADLOCATION "Helytelen pozíció"        // 0x0B Addressed PageID is beyond the finger library
#define D_FP_DBRANGEFAIL "DB tartomány hiba"      // 0x0C Error when reading template from library or invalid template
#define D_FP_UPLOADFEATUREFAIL "Feltöltési hiba" // 0x0D Error when uploading template
#define D_FP_PACKETRESPONSEFAIL "Válaszcsomag hiba" // 0x0E Module failed to receive the following data packages
#define D_FP_UPLOADFAIL "Feltöltési hiba"         // 0x0F Error when uploading image
#define D_FP_DELETEFAIL "Törlési hiba"         // 0x10 Failed to delete the template
#define D_FP_DBCLEARFAIL "Könyvtár törlési hiba"      // 0x11 Failed to clear finger library
#define D_FP_PASSFAIL "Jelszó hiba"         // 0x13 Find whether the fingerprint passed or failed
#define D_FP_INVALIDIMAGE "Érvénytelen kép"      // 0x15 Failed to generate image because of lac of valid primary image
#define D_FP_FLASHERR "Flash írási hiba"      // 0x18 Error when writing flash
#define D_FP_INVALIDREG "Érvénytelen szám"       // 0x1A Invalid register number
#define D_FP_ADDRCODE "Cím kód"           // 0x20 Address code
#define D_FP_PASSVERIFY "Jelszó ellenőrizve"    // 0x21 Verify the fingerprint passed
#define D_FP_UNKNOWNERROR "Hiba"              // Any other error

// xsns_83_neopool.ino
#define D_NEOPOOL_MACH_NONE               "NeoPool"           // Machine names
#define D_NEOPOOL_MACH_HIDROLIFE          "Hidrolife (yellow)"
#define D_NEOPOOL_MACH_AQUASCENIC         "Aquascenic (blue)"
#define D_NEOPOOL_MACH_OXILIFE            "Oxilife (green)"
#define D_NEOPOOL_MACH_BIONET             "Bionet (light blue)"
#define D_NEOPOOL_MACH_HIDRONISER         "Hidroniser (red)"
#define D_NEOPOOL_MACH_UVSCENIC           "UVScenic (lilac)"
#define D_NEOPOOL_MACH_STATION            "Station (orange)"
#define D_NEOPOOL_MACH_BRILIX             "Brilix"
#define D_NEOPOOL_MACH_GENERIC            "Generic"
#define D_NEOPOOL_MACH_BAYROL             "Bayrol"
#define D_NEOPOOL_MACH_HAY                "Hay"
#define D_NEOPOOL_FILTRATION_MANUAL       "Manual"            // Filtration modes
#define D_NEOPOOL_FILTRATION_AUTO         "Auto"
#define D_NEOPOOL_FILTRATION_HEATING      "Heating"
#define D_NEOPOOL_FILTRATION_SMART        "Smart"
#define D_NEOPOOL_FILTRATION_INTELLIGENT  "Intelligent"
#define D_NEOPOOL_FILTRATION_BACKWASH     "Backwash"
#define D_NEOPOOL_FILTRATION_NONE         ""                  // Filtration speed level
#define D_NEOPOOL_FILTRATION_SLOW         "slow"
#define D_NEOPOOL_FILTRATION_MEDIUM       "medium"
#define D_NEOPOOL_FILTRATION_FAST         "fast"
#define D_NEOPOOL_TYPE                    "Típus"              // Sensor & relais names
#define D_NEOPOOL_REDOX                   "Redox"
#define D_NEOPOOL_CHLORINE                "Chlorine"
#define D_NEOPOOL_CONDUCTIVITY            "Conductivity"
#define D_NEOPOOL_IONIZATION              "Ionization"
#define D_NEOPOOL_HYDROLYSIS              "Hydrolysis"
#define D_NEOPOOL_RELAY                   "Relay"
#define D_NEOPOOL_RELAY_FILTRATION        "Filtration"
#define D_NEOPOOL_RELAY_LIGHT             "Light"
#define D_NEOPOOL_RELAY_PH_ACID           "Acid pump"
#define D_NEOPOOL_RELAY_PH_BASE           "Base pump"
#define D_NEOPOOL_RELAY_RX                "Redox level"
#define D_NEOPOOL_RELAY_CL                "Chlorine pump"
#define D_NEOPOOL_RELAY_CD                "Brine pump"
#define D_NEOPOOL_TIME                    "Idő"
#define D_NEOPOOL_FILT_MODE               "Filtration"
#define D_NEOPOOL_POLARIZATION            "Pol"               // Sensor status
#define D_NEOPOOL_PR_OFF                  "PrOff"
#define D_NEOPOOL_SETPOINT_OK             "Ok"
#define D_NEOPOOL_COVER                   "Cover"
#define D_NEOPOOL_SHOCK                   "Shock"
#define D_NEOPOOL_ALARM                   "! "
#define D_NEOPOOL_LOW                     "Low"
#define D_NEOPOOL_FLOW1                   "FL1"
#define D_NEOPOOL_FLOW2                   "FL2"
#define D_NEOPOOL_PH_HIGH                 "too high"          // ph Alarms
#define D_NEOPOOL_PH_LOW                  "too low"
#define D_NEOPOOL_PUMP_TIME_EXCEEDED      "pump time exceeded"

#endif  // _LANGUAGE_HU_HU_H_
